/*
	`Xg̎
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*--- j[ ---*/
typedef enum {
	Term, Insert, Append, Delete, Print, Clear
} Menu;

/*--- m[h ---*/
typedef struct __node {
	int  no;				/* ԍ */
	char name[10];			/* O */
	struct __node *next;	/* 㑱m[hւ̃|C^ */
} Node;

/*--- m[h̊eoɒlݒ ----*/
void SetNode(Node *x, int no, const char *name, const Node *next)
{
	x->no   = no;
	x->next = next;
	strcpy(x->name, name);
}

/*--- ̃m[hm ---*/
Node *AllocNode(void)
{
	return calloc(1, sizeof(Node));
}

/*--- 擪ւ̃m[h} ---*/
void InsertNode(Node **top, int no, const char *name)
{
	Node *ptr = *top;
	*top = AllocNode();
	SetNode(*top, no, name, ptr);	/* next́A܂Ő擪m[hw */
}

/*--- ւ̃m[hǉ ---*/
void AppendNode(Node **top, int no, const char *name)
{
	if (*top == NULL)						/* Xgł */
		InsertNode(top, no, name);			/* 擪ɑ} */
	else {
		Node *ptr = *top;
		while (ptr->next != NULL)			/* m[h */
			ptr = ptr->next;
		ptr->next = AllocNode();
		SetNode(ptr->next, no, name, NULL);
	}
}

/*--- 擪m[h̍폜 ---*/
void DeleteNode(Node **top)
{
	if (*top != NULL) {						/* XgłȂ */
		Node *ptr = (*top)->next;
		free(*top);
		*top = ptr;
	}
}

/*--- ׂẴm[h̍폜 ---*/
void ClearList(Node **top)
{
	while (*top != NULL)					/* XgɂȂ܂ */
		DeleteNode(top);					/* 擪̃m[h폜 */
}

/*--- ׂẴm[h̕\ ---*/
void PrintList(const Node **top)
{
	Node *ptr = *top;

	puts("yꗗ\z");
	while (ptr != NULL) {
		printf("%5d %-10.10s\n", ptr->no, ptr->name);
		ptr = ptr->next;
	}
}

/*--- `Xg̏ ---*/
void InitList(Node **top)
{
	*top = NULL;
}

/*--- `Xǧn ---*/
void TermList(Node **top)
{
	ClearList(top);						/* ׂẴm[h폜 */
}

/*--- f[^̓ ---*/
Node Read(const char *message)
{
	Node temp;

	printf("%sf[^͂ĂB\n", message);

	printf("ԍF");   scanf("%d", &temp.no);
	printf("OF");   scanf("%s", temp.name);

	return temp;
}

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int	 ch;

	do {
		printf("\n(1) 擪Ƀm[h}   (2) Ƀm[hǉ\n");
		printf("(3) 擪̃m[h폜   (4) Sm[h\\n");
		printf("(5) Sm[h폜       (0)        I    F ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Clear);
	return (Menu)ch;
}

/*--- C ---*/
int main(void)
{
	Menu menu;
	Node *list;					/* 擪m[hւ̃|C^ */

	InitList(&list);			/* `Xg̗pJn */

	do {
		Node x;
		switch (menu = SelectMenu()) {
		 case Insert: x = Read("擪ɑ}");
					  InsertNode(&list, x.no, x.name);
					  break;
		 case Append: x = Read("ɒǉ");
					  AppendNode(&list, x.no, x.name);
					  break;
		 case Delete: DeleteNode(&list);
					  break;
		 case Print : PrintList(&list);
					  break;
		 case Clear : ClearList(&list);
					  break;
		}
	} while (menu != Term);

	TermList(&list);			/* `Xg̗pI */

	return 0;
}
