/*
	QT؂̎EQ
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LEN   128			/* O̔z */
#define STK_SIZE  100			/* X^bN̗vf */

/*--- j[ ---*/
typedef enum {
	Term, Insert, Search, Next, Prev, Print
} Menu;

/*--- Q؂̃m[h ---*/
typedef struct __bnode {
	char name[MAX_LEN];			/* O */
	struct __bnode *left;		/* qm[hւ̃|C^ */
	struct __bnode *right;		/* Eqm[hւ̃|C^ */
} BinNode;

/*--- m[hmۂ ---*/
BinNode *AllocNode(void)
{
	return (BinNode *)calloc(1, sizeof(BinNode));
}

BinNode *stk[STK_SIZE];			/* Tp|C^̃X^bN */
int     ptr;					/* X^bN|C^ */

/*--- G[\ ---*/
void Error(void)
{
	puts("ERROR");
}

/*--- m[h̑} ---*/
BinNode *InsertNode(BinNode *p, const BinNode *w)
{
	int cond;

	if (p == NULL) {
		p = AllocNode();
		strcpy(p->name, w->name);
		p->left = p->right = NULL;
	} else if ((cond = strcmp(w->name, p->name)) == 0)
		printf("yG[z%s͊ɓo^Ă܂B\n", w->name);
	else if (cond < 0)
		p->left	 = InsertNode(p->left, w);			/* ̎qɒ */
	else
		p->right = InsertNode(p->right, w);			/* E̎qɒ */
	return p;
}

/*--- m[h̒T ---*/
void SearchNode(BinNode *root, const BinNode *w)
{
	if (root != NULL) {
		BinNode *p = root;
		ptr = 0;

		while (1) {
			if (p != NULL) {
				int cond;

				stk[ptr++] = p;					/* X^bNɃvbV */
				if ((cond = strcmp(w->name, p->name)) == 0) {
					printf("%s͓o^Ă܂B\n", w->name);
					ptr--;
					break;
				}
				p = (cond < 0) ? p->left : p->right;
			} else {
				printf("%s͓o^Ă܂B\n", w->name);
				ptr = -1;
				break;
			}
		}
	}
}

/*--- rootƂ镔؂ŏisw=0j^őisw=1jT ---*/
BinNode *SearchMinMax(const BinNode *root, int sw)
{
	if (root == NULL)
		return NULL;
	else {
		BinNode *p = root;

		while (p != NULL) {
			stk[++ptr] = p;							/* X^bNɃvbV */
			p = (sw == 0) ? p->left : p->right;
		}
		return stk[ptr];
	}
}

/*--- ̃m[hi傫L[lj̒T ---*/
void SrchNext(void)
{
	if (ptr == -1)									/* X^bN */
		Error();
	else {
		BinNode *p;

		if (stk[ptr]->right != NULL)				/* E̎q */
			p = SearchMinMax(stk[ptr]->right, 0);
		else {										/* E̎q͂Ȃ */
			char *name = stk[ptr]->name;
			while (1) {
				if (--ptr < 0) {
					p = NULL;
					break;
				}
				if (strcmp(stk[ptr]->name, name) > 0) {
					p = stk[ptr];
					break;
				}
			}
		}
		if (p == NULL)
			Error();
		else
			printf("f[^́m%snłB\n", p->name);
	}
}

/*--- Õm[hiL[lj̒T ---*/
void SrchPrev(void)
{
	if (ptr == -1)									/* X^bN */
		Error();
	else {
		BinNode *p;

		if (stk[ptr]->left != NULL)					/* ̎q */
			p = SearchMinMax(stk[ptr]->left, 1);
		else {										/* ̎q͂Ȃ */
			char *name = stk[ptr]->name;
			while (1) {
				if (--ptr < 0) {
					p = NULL;
					break;
				}
				if (strcmp(stk[ptr]->name, name) < 0) {
					p = stk[ptr];
					break;
				}
			}
		}
		if (p == NULL)
			Error();
		else
			printf("f[^́m%snłB\n", p->name);
	}
}

/*--- ؂̑SvfL[l̏ɕ\iċAŁj ---*/
void PrintTree(const BinNode *root)
{
	if (root != NULL) {
		BinNode *p = root;
		BinNode *stk[STK_SIZE];			/* X^bN */
		int ptr = 0;					/* X^bN|C^ */

		while (1) {
			if (p != NULL) {
				stk[ptr++] = p;				/* pvbV */
				p = p->left;				/* ̎qɒ */
			} else if (ptr > 0) {
				p = stk[--ptr];				/* |bv */
				printf("%s\n", p->name);	/* \ */
				p = p->right;				/* E̎qɒ */
			} else
				break;
		}
	}
}

/*--- ؂̑Svf ---*/
void FreeTree(BinNode *p)
{
	if (p != NULL) {
		FreeTree(p->left);			/* p̍؂ */
		FreeTree(p->right);			/* p̉E؂ */
		free(p);					/* p */
	}
}

/*--- f[^̓ ---*/
BinNode Read(const char *message)
{
	BinNode temp;

	printf("%s閼O͂Ă : ", message);
	scanf("%s", temp.name);

	return temp;
}

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf(
			"\n(1)}  (2)T  (3)m[h  (4)Om[h  (5)\  (0)I : ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Print);

	return (Menu)ch;
}

/*--- C֐ ---*/
int main(void)
{
	Menu menu;
	BinNode *root;			/* ւ̃|C^ */

	root = NULL;
	ptr  = -1;
	do {
		BinNode x;
		switch (menu = SelectMenu()) {
		 case Insert :	x = Read("}");
						root = InsertNode(root, &x);
						break;
		 case Search :	x = Read("T");
						SearchNode(root, &x);
						break;
		 case Next	 :	SrchNext();
						break;
		 case Prev	 :	SrchPrev();
						break;
		 case Print	 :	puts("--- ꗗ\ ---");
						PrintTree(root);
						break;
		}
	} while (menu != Term);

	FreeTree(root);			/* ׂẴm[h */

	return 0;
}
